'***********************************************
'
' Restart Spooler and Printer
'
' Date: 06/11/2008
' Version: 4.2
'
'***********************************************

main

'***********************************************
' Main execution starts here
'***********************************************
Sub main
	Dim answer
	Dim objShell
 	Dim sOS

 	sOS = GetOS
    
  	If WScript.Arguments.length =0  Then
		
	  Set objShell = CreateObject("Shell.Application")
	  'Pass a bogus argument with leading blank space, say [ uac]
	  If sOS = "Windows Vista" or sOS = "Windows 7" Then
		  objShell.ShellExecute "wscript.exe", Chr(34) & _
		  		WScript.ScriptFullName & Chr(34) & " uac", 0, "runas", 1
	  Else
		  objShell.ShellExecute "wscript.exe", Chr(34) & _
		  		WScript.ScriptFullName & Chr(34) & " uac", 0, "", 1	  
	  End If
	Else
		Restart	
	End If
 
End Sub


'***********************************************
' Main execution starts here
'***********************************************
Sub Restart

	Dim ArgObj
	Dim BatchFile
	Dim sCommand
	Dim WshShell ' as object
	Dim objEnv ' as collection
	Dim sGetMyVar  ' as string
	Dim sPrinterShutDown

	' Get the Arguments object
	Set ArgObj = WScript.Arguments

	Set WshShell = WScript.CreateObject("WScript.Shell")
	Set objEnv = WshShell.Environment("PROCESS")
	objEnv("Year") = Year(now())
	objEnv("Month") = Right("0" & Month(now()), 2)
	objEnv("Day") = Right("0" & Day(now()), 2)
	objEnv("Hour") = Right("0" & Hour(now()), 2)
	objEnv("Minute") = Right("0" & Minute(now()), 2)
	objEnv("Second") = Right("0" & Second(now()), 2)

	'Shutdown
	ProcessTerminate "KODAKMDN.EXE"
	ProcessTerminate "KODAKPRE.EXE"
	ProcessTerminate "KODAKMUI.EXE"
	ProcessTerminate "EKIJ5000MDN.EXE"
	ProcessTerminate "EKIJ5000PRE.EXE"
	ProcessTerminate "EKIJ5000MUI.EXE"

	'WshShell.Run "%COMSPEC% /C COPY C:\EKIJ5000.LOG C:\EKIJ5000_%YEAR%%MONTH%%DAY%-%HOUR%%MINUTE%%SECOND%.LOG",7,true
	WshShell.Run "Net Stop Spooler",0,true

	sPrinterShutDown= sPrinterShutDown& "Turn the printer off." & vbCrLf
	sPrinterShutDown= sPrinterShutDown& "Wait 10 seconds." & vbCrLf
	sPrinterShutDown= sPrinterShutDown& "Click 'OK'." & vbCrLf
	sPrinterShutDown= sPrinterShutDown& "Wait 10 seconds." & vbCrLf
	sPrinterShutDown= sPrinterShutDown& "Turn the printer on." & vbCrLf

	MsgBox sPrinterShutDown, 0, "Kodak EasyShare All-in-One printer"

	WshShell.Run "%COMSPEC% /C del %WINDIR%\system32\spool\PRINTERS\*.* /Q",0,true
	WshShell.Run "Net Start Spooler",0,true

	On Error Resume Next
	WshShell.Run "%WINDIR%\system32\spool\drivers\w32x86\3\EKIJ5000MUI.EXE",7,true
	WshShell.Run "%WINDIR%\system32\spool\drivers\x64\3\EKIJ5000MUI.EXE",7,true
	On Error Goto 0
End Sub

'***********************************************
' Function: TerminateProcess
' Purpose:  Terminates a process
' Input:      Name of process
'***********************************************
Private Function ProcessTerminate( strProcess )
    Dim colProcessList, objProcess

    Set colProcessList = GetObject("Winmgmts:").ExecQuery _
        ("Select * from Win32_Process Where Name ='" & strProcess & "'")
    For Each objProcess in colProcessList
        objProcess.Terminate( )
    Next

    Set colProcessList = Nothing
End Function

'***********************************************
' Function: GetOS
' Purpose:  Get OS sing
'***********************************************
Private Function GetOS
    
    Dim oWMI, oItem, colItems
    Dim sComputer, VerOS, VerBig, Ver9x, Version9x, OS

    ' Here is where we interrogate the Operating System
    ' On Error Resume Next

    ' Get the computer name dot = this computer.
    sComputer = "."
    ' This is where WMI interrogates the operating system
    Set oWMI = GetObject("winmgmts:\\" & sComputer & "\root\cimv2")

    Set colItems = oWMI.ExecQuery("Select * from Win32_OperatingSystem",,48)

    ' Here we filter Version from the dozens of properties
    For Each oItem in colItems
        VerBig = Left(oItem.Version,3)
    Next

    ' Spot VerBig variable in previous section
    ' Note the output variable is called OSystem

    Select Case VerBig
        Case "6.1" GetOS = "Windows 7"
        Case "6.0" GetOS = "Windows Vista"
        Case "5.2" GetOS = "Windows 2003"
        Case "5.1" GetOS = "Windows XP"
        Case "5.0" GetOS = "Windows 2000"
        Case "4.0" GetOS = "Windows NT"
        Case Else GetOS = "Unknown"
    End Select

End Function
