'***********************************************
'
' Uninstall Printer
'
' Date: 06/01/2010
' Version: 5.3-Prototype
'
'***********************************************
Option Explicit

Const wbemFlagReturnImmediately = &h10
Const wbemFlagForwardOnly = &h20

Dim ArgObj
Dim BatchFile
Dim sCommand
Dim WshShell
Dim oEnv
Dim oFileSystem
Dim oWMIService
Dim sGetMyVar
Dim sPrinterShutDown
Dim sPrinter
Dim sPrinterDriver_list
Dim sPrinterDriver_array
Dim oItem
Dim colInstalledPrinters
Dim sPrinterInstalled_list
Dim sPrinterInstalled_array
Dim sPrinterDriverInstalled_list
Dim sPrinterDriverInstalled_array
Dim colInstalledPorts
Dim sTCPIPPort
Dim sTCPIPPorts_list
Dim sTCPIPPorts_array
Dim sHID
Dim sHID_list
Dim sHID_array
Dim sComputer

main

'***********************************************
' Main execution starts here
'***********************************************
Sub main
	Dim answer
	Dim objShell
 	Dim sOS

 	sOS = GetOS
    
  	If WScript.Arguments.length =0  Then
		
	  Set objShell = CreateObject("Shell.Application")
	  'Pass a bogus argument with leading blank space, say [ uac]
	  If sOS = "Windows Vista" or sOS = "Windows 7" Then
		  objShell.ShellExecute "wscript.exe", Chr(34) & _
		  		WScript.ScriptFullName & Chr(34) & " uac", 0, "runas", 1
	  Else
		  objShell.ShellExecute "wscript.exe", Chr(34) & _
		  		WScript.ScriptFullName & Chr(34) & " uac", 0, "", 1	  
	  End If
	Else
		answer = MsgBox ("Do you wish to delete all your Kodak EKIJ5000 Inkjet printers?", 4, "KODAK EASYSHARE All-in-One Printer")
	    	    
	    If answer = 6 Then
		    DeleteAllPrinters
		End If

	End If
 
End Sub


'***********************************************
' Function: DeleteAllPrinters
' Purpose:  Delete All Printers
'***********************************************
Private Function DeleteAllPrinters
Dim objExplorer

	set objExplorer = createobject("internetexplorer.application")

	objExplorer.navigate2 "about:blank"  
	objExplorer.Width = 400
	objExplorer.Height = 240
	objExplorer.Left = 0
	objExplorer.Top = 0
	objExplorer.toolbar = false  
	objExplorer.menubar = false  
	objExplorer.statusbar = false  
	objExplorer.visible = True
	objExplorer.document.write "<font color=red>"
	objExplorer.document.write "Do not close window!  It will close on its own when done! <br /> <br /> "
	objExplorer.document.write "<font color=black>"
	objExplorer.document.write "Deleting Printers! <br /> <br /> "
	objExplorer.document.write "<font color=grean>"
	objExplorer.document.write "<MARQUEE WIDTH=100% BEHAVIOR=ALTERNATE>Please be patient.... </MARQUEE><br>"
	objExplorer.document.title = "Deleting Printers!"
	objExplorer.document.write "<font color=red>"

    sPrinterDriver_list = "EasyShare AIO 3040@" & _
                          "EASYSHARE 5100 AiO Printer@" & _
                          "EASYSHARE 5300 AiO Printer@" & _
                          "EASYSHARE 5500 AiO Printer@" & _
                          "KODAK 5100 AiO@" & _
                          "KODAK 5300 AiO@" & _
                          "KODAK 5500 AiO@" & _
                          "KODAK 830@" & _
                          "KODAK 3300 AiO@" & _               
                          "KODAK ESP-3 AiO@" & _
                          "KODAK ESP 5 AiO@" & _
                          "KODAK ESP 7 AiO@" & _
                          "KODAK ESP 9 AiO@" & _
                          "KODAK ESP 3200 AiO@" & _
                          "KODAK ESP 5200 AiO@" & _
                          "KODAK ESP 3200 Series AiO@" & _
                          "KODAK ESP 5200 Series AiO@" & _
                          "KODAK ESP Office 4100 Series AiO@" & _
                          "KODAK ESP Office 6100 Series AiO@" & _
                          "ESPOffice 4100 Series AiO@" & _
                          "ESPOffice 6100 Series AiO@" & _
                          "KODAK ESP 7200 Series AiO@" & _
                          "KODAK ESP 9200 Series AiO@" & _
                          "KODAK ESP 5 Prototype AiO@" & _
			       		  "KODAK ESP 3470 AiO@" & _
			       		  "KODAK ESP 3420 AiO@" & _
                          "KODAK ESP LION AiO"

    sHID_list  = "EastmanKodakCo_ABCD " & _
                 "Eastman_Kodak_Compan2427 " & _ 
                 "Eastman_Kodak_Compan05CC " & _
                 "Eastman_Kodak_Compan0A83 " & _
                 "Eastman_Kodak_Compan0Ae7 " & _
                 "Eastman_Kodak_CompanCAC4 " & _
                 "Eastman_Kodak_Compan0AE7 " & _
                 "Eastman_Kodak_Compan0A83 " & _ 
                 "Eastman_Kodak_Compan7C78 " & _
                 "Eastman_Kodak_CompanEAEC " & _
                 "Eastman_Kodak_Compan8CEC " & _
                 "Eastman_Kodak_Compan880B " & _
                 "Eastman_Kodak_Compan2067 " & _
                 "Eastman_Kodak_Compan9580 " & _
                 "Eastman_Kodak_Compan55FB " & _
                 "Eastman_Kodak_Compan9492 " & _
                 "Eastman_Kodak_CompanD4A7 " & _
                 "Eastman_Kodak_CompanB7A1 " & _
                 "Eastman_Kodak_Compan89C8 " & _
                 "Eastman_Kodak_CompanA348 " & _
                 "Eastman_Kodak_CompanFDE6 " & _
                 "Eastman_Kodak_CompanFC64 " & _
                 "Eastman_Kodak_CompanD5B1 " & _
                 "Eastman_Kodak_CompanBDE6 " & _
                 "Eastman_Kodak_CompanEC23 " & _
                 "Eastman_Kodak_Compan56CB " & _
				 "Eastman_Kodak_Compan0AAC " & _
                 "Eastman_Kodak_CompanAC2E " & _
                 "Eastman_Kodak_CompanF92E " & _
                 "Eastman_Kodak_CompanF0A9"

    ' Get the Arguments object
    Set ArgObj = WScript.Arguments

    Set WshShell = WScript.CreateObject("WScript.Shell")
    Set oEnv = WshShell.Environment("PROCESS")
    Set oFileSystem = WScript.CreateObject("Scripting.FileSystemObject")

    ' Get Arrays
    sPrinterDriver_array = Split(sPrinterDriver_list, "@")
    sHID_array = Split(sHID_list, " ")

    'Get installed printers and ports
    sComputer = "."
    On Error Resume Next
    Set oWMIService = GetObject("winmgmts:" _
            & "{impersonationLevel=impersonate}!\\" & sComputer & "\root\cimv2")

    Set colInstalledPrinters = oWMIService.ExecQuery _
             ("Select * from Win32_Printer", "WQL", _
             wbemFlagReturnImmediately + wbemFlagForwardOnly)
       
    For Each oItem In colInstalledPrinters 
        For Each sPrinter in sPrinterDriver_array
           If  (oItem.DriverName = sPrinter) Then
              sPrinterInstalled_list = sPrinterInstalled_list & oItem.Name & "@"
              sPrinterDriverInstalled_list =  sPrinterDriverInstalled_list & oItem.DriverName & "@"
           End If           
        Next        
    Next
    If Right(sPrinterInstalled_list,1)="@" Then
      sPrinterInstalled_list=Left(sPrinterInstalled_list,Len(sPrinterInstalled_list)-1)
    End If
    If Right(sPrinterDriverInstalled_list,1)="@" Then
      sPrinterDriverInstalled_list=Left(sPrinterDriverInstalled_list,Len(sPrinterDriverInstalled_list)-1)
    End If

    Set colInstalledPorts = oWMIService.ExecQuery _
             ("Select * from Win32_TCPIPPrinterPort", "WQL", _
             wbemFlagReturnImmediately + wbemFlagForwardOnly)
       
    For Each oItem In colInstalledPorts 
       sTCPIPPorts_list = sTCPIPPorts_list & oItem.Name & "@"   
    Next
    If Right(sTCPIPPorts_list,1)="@" Then
      sTCPIPPorts_list=Left(sTCPIPPorts_list,Len(sTCPIPPorts_list)-1)
    End If
    On Error Goto 0

    'Get arrays
    sPrinterInstalled_array = Split(sPrinterInstalled_list, "@")
    sPrinterDriverInstalled_array = Split(sPrinterDriverInstalled_list, "@")
    sTCPIPPorts_array = Split(sTCPIPPorts_list, "@")

   'Delete Forms if Forms have changed.
   'Remove possible registry entiries, spooler restart required.
   'Need to find a way to call Windows OpenPrinter, EnumForms, DeleteForm, ClosePrinter
	Dim answer    
    answer = MsgBox ("Do you wish to delete all forms that are asscociated with your Kodak EKIJ5000 printers?", 4, "KODAK EASYSHARE All-in-One Printer")
    
    If answer = 6 Then
   	    For Each sPrinter in sPrinterInstalled_array
	        Call DeleteFormRegEntrys(sPrinter)
	    Next
	End If

    'Delete installed Printers
    For Each sPrinter in sPrinterInstalled_array
        Call DeletePrinter(sPrinter)
    Next

    ' Tell the Status Monitor to cleanup (Delete all its settings)
    Dim pathMUI
    On Error Resume Next
    pathMUI = oEnv("SYSTEMROOT") & "\system32\spool\drivers\w32x86\3\ekij5000mui.exe /cleanup" 
    WshShell.Run pathMUI,0,true
    pathMUI = oEnv("SYSTEMROOT") & "\system32\spool\drivers\x64\3\ekij5000mui.exe /cleanup" 
    WshShell.Run pathMUI,0,true
    On Error Goto 0

    ' Vista - Remove Driver Store / Driver Package
    For Each sHID in sHID_array
        Call DeletePackageViaOEM_INF(sHID)
    Next
    
    'Delete all Driver of known printers
    For Each sPrinter in sPrinterDriver_array
        Call DeletePrinterDriver(sPrinter)
    Next

    ' Remove OEM INF files from Windows INF directory
    For Each sHID in sHID_array
        Call DeleteOEM_INF(sHID)
    Next

    'Remove our TCP/IP ports
    'For Each sTCPIPPort in sTCPIPPorts_array
    '    Call DeleteTCPIPPort(sTCPIPPort)
    'Next

    'Clean up all spurios entities
    'Shutdown
    Call ProcessTerminate("KODAKMDN.EXE")
    Call ProcessTerminate("KODAKPRE.EXE")
    Call ProcessTerminate("KODAKMUI.EXE")
    Call ProcessTerminate("EKIJ5000MDN.EXE")
    Call ProcessTerminate("EKIJ5000PRE.EXE")
    Call ProcessTerminate("EKIJ5000MUI.EXE")
    Call ProcessTerminate("EasyShare.EXE")

    'Stop spooler, need to do this to make sure it shuts down
    WshShell.Run "Net Stop Spooler",0,true
    WshShell.Run "Net Start Spooler",0,true
    WshShell.Run "Net Stop Spooler",0,true

    'Delete installed files if any still exist
    Call DeleteFiles(sHID_array)

    'Remove possible registry entires.
    For Each sPrinter in sPrinterDriver_array
        Call DeletePrinterRegEntry(sPrinter)
    Next

    Call DeletePPRRegEntry("KODAK Processor")
    Call DeletePPRRegEntry("KODAK EASYSHARE 5000 Series All-in-One Printer")
    Call DeletePPRRegEntry("KODAK EASYSHARE All-in-One Printer")

    Call DeleteLMRegEntry("KODAK Monitor")
    Call DeleteLMRegEntry("KODAK EASYSHARE 5000 Series All-in-One Printer")
    Call DeleteLMRegEntry("KODAK EASYSHARE All-in-One Printer")

    ' Start Spooler
    WshShell.Run "Net Start Spooler",0,true

	objExplorer.Navigate "about:blank"  
	objExplorer.ToolBar = 0
	objExplorer.StatusBar = 0
	objExplorer.Width = 400
	objExplorer.Height = 240
	objExplorer.Left = 0
	objExplorer.Top = 0
	objExplorer.document.write "<font color=red>"
	objExplorer.document.write "Printers Deleted!"
	objExplorer.document.title = "Printers Deleted!"
	WScript.Sleep 5000
	objexplorer.Quit


End Function

'***********************************************
' Function: DeletePrinterRegEntry
' Purpose:  Delete Printer Registery Entry
' Input:      Name of Driver
'***********************************************
Private Function DeletePrinterRegEntry( sDriverName )
    On Error Resume Next
    
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "\DsDriver\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "\DsSpooler\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "\PnPData\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "\PrinterDriverData\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "\"

    For index = 0 To 9 
        WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "," & index & "\DsDriver\"
        WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "," & index & "\DsSpooler\"
        WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "," & index & "\PnPData\"
        WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "," & index & "\PrinterDriverData\"
        WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & sDriverName  & "," & index & "\"
    Next
    
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Environments\Windows NT x86\Drivers\Version-3\" & sDriverName & "\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Environments\Windows x64\Drivers\Version-3\" & sDriverName & "\"
    WshShell.RegDelete "HKCU\Printers\DevModePerUser\" & sDriverName 
    WshShell.RegDelete "HKCU\Printers\DevModes2\" & sDriverName
    
    On Error Goto 0
End Function


'***********************************************
' Function: DeletePPRRegEntry
' Purpose:  Delete Printer Processor Registery Entry
' Input:      Name of Driver
'***********************************************
Private Function DeletePPRRegEntry ( sPPRName )
    On Error Resume Next
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Environments\Windows NT x86\Print Processors\" &  sPPRName & "\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Environments\Windows x64\Print Processors\" &  sPPRName & "\"
    On Error Goto 0
End Function

'***********************************************
' Function: DeleteLMRegEntry
' Purpose:  Delete Printer Processor Registery Entry
' Input:      Name of Driver
'***********************************************
Private Function DeleteLMRegEntry ( sLMName )
    On Error Resume Next
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Monitors\" & sLMName & "\"
    WshShell.RegDelete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Run\EKIJ5000StatusMonitor"
    WshShell.RegDelete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Run\KODAKIJStatusMonitor"
    On Error Goto 0
End Function

'***********************************************
' Function: TerminateProcess
' Purpose:  Terminates a process
' Input:      Name of process
'***********************************************
Private Function ProcessTerminate( sProcess )
    Dim colProcessList, oProcess

    On Error Resume Next   
    Set colProcessList = GetObject("Winmgmts:").ExecQuery _
        ("Select * from Win32_Process Where Name ='" & sProcess & "'")
    For Each oProcess in colProcessList
        oProcess.Terminate( )
    Next

    Set colProcessList = Nothing
    On Error Goto 0  
  
End Function

'***********************************************
' Function: DeletePackageViaOEM_INF
' Purpose:  Delete Package OEM#.INF
' Input:    String to find in OEM#.inf
'***********************************************
Private Function DeletePackageViaOEM_INF( sDeleteOn )

    Dim i
    Dim oFile
    Dim sText
    Dim sFile
    Dim sFilePNF
    Dim sOS
    Dim sExecCommand

    sOS = GetOS
    
    If sOS = "Windows Vista" or sOS = "Windows 7" Then
        For i = 0 to 999 Step 1
            sFile = oEnv("SYSTEMROOT") & "\INF\OEM" & i & ".INF"
            sFilePNF = oEnv("SYSTEMROOT") & "\INF\OEM" & i & ".PNF"
            If oFileSystem.FileExists(sFile) then 	
                On Error Resume Next
                Set oFile = oFileSystem.OpenTextFile(sFile, 1)
                sText = oFile.ReadAll
                oFile.Close
                If InStr(1, sText, sDeleteOn, 1) <> 0 Then
                    sExecCommand= "pnputil.exe -f -d OEM" & i & ".INF"                            
                    WshShell.Run sExecCommand,0,true	
                End if
                On Error Goto 0
            End if
        Next
    End If

End Function


'***********************************************
' Function: DeleteOEM_INF
' Purpose:  Delete OEM#.INF
' Input:    String to find in OEM#.inf
'***********************************************
Private Function DeleteOEM_INF( sDeleteOn )
    Dim i
    Dim oFile
    Dim sText
    Dim sFile
    Dim sFilePNF
    For i = 0 to 999 Step 1
        sFile = oEnv("SYSTEMROOT") & "\INF\OEM" & i & ".INF"
        sFilePNF = oEnv("SYSTEMROOT") & "\INF\OEM" & i & ".PNF"
        If oFileSystem.FileExists(sFile) then 	
            On Error Resume Next
            Set oFile = oFileSystem.OpenTextFile(sFile, 1)
            sText = oFile.ReadAll
            oFile.Close
            On Error Goto 0
            If InStr(1, sText, sDeleteOn, 1) <> 0 Then
                oFileSystem.DeleteFile sFile, true
                oFileSystem.DeleteFile sFilePNF, true
            End if
        End if
    Next
End Function

'***********************************************
' Function: DeleteOEM_INF
' Purpose:  Delete OEM#.INF
' Input:    String to find in OEM#.inf
'***********************************************
Private Function DeleteOEM_INF( sDeleteOn )
    Dim i
    Dim oFile
    Dim sText
    Dim sFile
    Dim sFilePNF
    For i = 0 to 999 Step 1
        sFile = oEnv("SYSTEMROOT") & "\INF\OEM" & i & ".INF"
        sFilePNF = oEnv("SYSTEMROOT") & "\INF\OEM" & i & ".PNF"
        If oFileSystem.FileExists(sFile) then 	
            On Error Resume Next
            Set oFile = oFileSystem.OpenTextFile(sFile, 1)
            sText = oFile.ReadAll
            oFile.Close
            On Error Goto 0
            If InStr(1, sText, sDeleteOn, 1) <> 0 Then
                On Error Resume Next
                oFileSystem.DeleteFile sFile, true
                oFileSystem.DeleteFile sFilePNF, true
                On Error Goto 0
            End if
        End if
    Next
End Function

'***********************************************
' Function: DeleteTCPIPPort
' Purpose:  Delete Standard TCP/IP Port
' Input:    String to find in port name
'***********************************************
Private Function DeleteTCPIPPort( sDeleteOn )
    Dim sExecCommand, sPath
    Dim Controller, RemoteScript

    sPath = GetPrintVBSPath
  
    If (InStr(1, sDeleteOn, "KodakESP", 1) <> 0) Then
        On Error Resume Next
        sExecCommand = "cscript " & sPath & "\prnport.vbs -d -r """ & sDeleteOn & """"
        WshShell.Run sExecCommand,0,true
    On Error Goto 0

    End If
    
End Function

'***********************************************
' Function: DeleteFiles
' Purpose:  Deletes driver files
' Input:      None
'***********************************************
Private Function DeleteFiles ( sHID_array )

   Dim sPrefixes_list
   Dim sDirectories_list
   Dim sFiles_list
   Dim sFile_Ext_list
   Dim sHID 
   Dim sPrefixes_array
   Dim sPrefix
   Dim sDirectories_array
   Dim sDirectory
   Dim sFiles_array
   Dim sFile
   Dim sFile_ext_array
   Dim sExt
   Dim i
   Dim sPath														   

   sDirectories_list = "w32x86 x64"
   
   sPrefixes_list    = "kodak ekij5000 ekij4 ekij5100 ekij5300 ekij5500 " & _
                      "ekij3000 ekij830 ekij3300 ekijesp3 ekijesp5 " & _
                      "ekijesp7 ekijesp9 ekij3200 ekij5200 ekij4100 " & _
                      "ekij6100 ekij7200 ekij9200 ekij4test ekij3420 ekij3470 " & _
		      		 "ekijlion ekijesplion ekijcoinst"
                      
   sFiles_list       = "IJ MDK MDN MUI PRE RES RIJ RRS SDK UIP"
   
   sFile_Ext_list    = ".exe .dll .gpd .bud .ini .hlp .gid .chm .exp .ilk .lib .map .pdb"


   sPrefixes_array    = Split(sPrefixes_list, " ")
   sDirectories_array = Split(sDirectories_list, " ")
   sFiles_array       = Split(sFiles_list, " ")
   sFile_ext_array   = Split(sFile_ext_list, " ")
   
   For Each sPrefix in sPrefixes_array
       For Each sDirectory in sDirectories_array
           ' Driver sFiles
           For Each sFile in sFiles_array
               For Each sExt in sFile_ext_array
                   sPath = oEnv("SYSTEMROOT") & "\system32\spool\drivers\" & sDirectory & "\3\" & sPrefix & sFile & sExt
                   On Error Resume Next
                   oFileSystem.DeleteFile(sPath), true
                   On Error Goto 0
                Next	              
           Next
           For Each sExt in sFile_ext_array
               sPath = oEnv("SYSTEMROOT") & "\system32\spool\drivers\" & sDirectory & "\3\" & sPrefix & sExt
               On Error Resume Next
               oFileSystem.DeleteFile(sPath), true
               On Error Goto 0
           Next	              
            
           'Print Processor
           sPath = oEnv("SYSTEMROOT") & "\system32\spool\prtprocs\" & sDirectory & "\" & sPrefix & "PPR.dll"
           On Error Resume Next
           oFileSystem.DeleteFile(sPath), true
           On Error Goto 0
     Next

     'Langauge Monitor
     sPath = oEnv("SYSTEMROOT") & "\system32\" & sPrefix & "MON.dll"
     On Error Resume Next
     oFileSystem.DeleteFile(sPath), true
     On Error Goto 0

     'Co-installer
     For i = 0 to 9 Step 1
        sPath = oEnv("SYSTEMROOT") & "\system32\" & sPrefix & "0" & i & ".dll"
        On Error Resume Next
        oFileSystem.DeleteFile(sPath), true
        On Error Goto 0
     Next
     For i = 10 to 99 Step 1
        sPath = oEnv("SYSTEMROOT") & "\system32\" & sPrefix & i & ".dll"
        On Error Resume Next
        oFileSystem.DeleteFile(sPath), true
        On Error Goto 0
     Next     
     
     'Job INI
     sPath = oEnv("SYSTEMDRIVE") & "\Documents and Settings\All Users\Application Data\Kodak\Kodak 5000 Series AiO\EKIJ5000_Job.ini"
     On Error Resume Next
     oFileSystem.DeleteFile(sPath), true
     On Error Goto 0

     'Usage File
     'sPath = oEnv("SYSTEMDRIVE") & "\Documents and Settings\All Users\Application Data\Kodak\Kodak 5000 Series AiO\EKIJ5000DriverUsage.xml"
     'On Error Resume Next
     'oFileSystem.DeleteFile(sPath), true
     'On Error Goto 0

    Next

    On Error Resume Next
    'XP 32-bit
    For Each sHID in sHID_array
        oFileSystem.DeleteFolder(oEnv("SYSTEMROOT") & "\system32\spool\drivers\w32x86\" & sHID) 
    Next
    
    'XP 64-bit
    For Each sHID in sHID_array
        oFileSystem.DeleteFolder(oEnv("SYSTEMROOT") & "\system32\spool\drivers\x64\" & sHID) 
    Next
    
    On Error Goto 0

End Function


'***********************************************
' Function: DeletePrinter
' Purpose:  Run Print VBS scripts to delete printer
' Input:    Printer Name  
'***********************************************
Private Function DeletePrinter( sDeleteOn  )
   
    Dim sExecCommand, sPath
    Dim Controller, RemoteScript

    sPath = GetPrintVBSPath
  
    On Error Resume Next
    sExecCommand = "cscript " & sPath & "\prnmngr.vbs -d -p """ & sDeleteOn & """"
    WshShell.Run sExecCommand,0,true
    On Error Goto 0

End  Function
 
'***********************************************
' Function: DeletePrinterDriver
' Purpose:  Run Print VBS scripts to delete driver 
' Input:    Driver Name  
'***********************************************
Private Function DeletePrinterDriver( sDeleteOn  )
   
    Dim sExecCommand, sPath
    Dim Controller, RemoteScript

    sPath = GetPrintVBSPath
  
    On Error Resume Next
    sExecCommand = "cscript " & sPath & "\prndrvr.vbs -d -m """ & sDeleteOn & """ -v 3 -e ""Windows NT x86"""
    WshShell.Run sExecCommand,0,true
    
    sExecCommand = "cscript " & sPath & "\prndrvr.vbs -d -m """ & sDeleteOn & """ -v 3 -e ""Windows x64"""
    WshShell.Run sExecCommand,0,true
    On Error Goto 0

End  Function

'***********************************************
' Function: DeleteFormRegEntry
' Purpose:  Delete Printer Forms Registery Entry
'           NOTE: DeletForm SDK SPI Should be used
'                 Not accessible from VBScript.
' Input:      Name of Driver
'***********************************************
Private Function DeleteFormRegEntrys ( sPrinter )

   Const wbemFlagReturnImmediately = &h10
   Const wbemFlagForwardOnly = &h20

   Dim Form_list
   Dim form_array
   Dim form
   Dim regKey
   Dim regEntry
   Dim sComputer

   On Error Resume Next
   scomputer = "."
   Set oWMIService = GetObject("winmgmts:" _
            & "{impersonationLevel=impersonate}!\\" & sComputer & "\root\cimv2")

   Set colInstalledPrinters = oWMIService.ExecQuery _
            ("Select * from Win32_Printer", "WQL", _
            wbemFlagReturnImmediately + wbemFlagForwardOnly)
   
   For Each oItem In colInstalledPrinters 
      If  (oItem.Name = sPrinter) Then
          Form_list = Join(oItem.PrinterPaperNames, "@")
      End If
   Next
   If Right(Form_list,1)="@" Then
      Form_list=Left(Form_list,Len(Form_list)-1)
   End If

   On Error Goto 0
 
   regKey =  "HKLM\SYSTEM\CurrentControlSet\Control\Print\Forms\"
   form_array = Split(Form_list, "@")
 
   On Error Resume Next
   For Each form in form_array
      If (form <> "B5") Then
          WshShell.RegDelete regKey & form
      End If
   Next
   On Error Goto 0
    
 End Function
 
'***********************************************
' Function: GetOS
' Purpose:  Get OS sing
'***********************************************
Private Function GetOS
    
    Dim oWMI, oItem, colItems
    Dim sComputer, VerOS, VerBig, Ver9x, Version9x, OS

    ' Here is where we interrogate the Operating System
    ' On Error Resume Next

    ' Get the computer name dot = this computer.
    sComputer = "."
    ' This is where WMI interrogates the operating system
    Set oWMI = GetObject("winmgmts:\\" & sComputer & "\root\cimv2")

    Set colItems = oWMI.ExecQuery("Select * from Win32_OperatingSystem",,48)

    ' Here we filter Version from the dozens of properties
    For Each oItem in colItems
        VerBig = Left(oItem.Version,3)
    Next

    ' Spot VerBig variable in previous section
    ' Note the output variable is called OSystem

    Select Case VerBig
        Case "6.1" GetOS = "Windows 7"
        Case "6.0" GetOS = "Windows Vista"
        Case "5.2" GetOS = "Windows 2003"
        Case "5.1" GetOS = "Windows XP"
        Case "5.0" GetOS = "Windows 2000"
        Case "4.0" GetOS = "Windows NT"
        Case Else GetOS = "Unknown"
    End Select

End Function

'***********************************************
' Function: GetPrintVBSPath
' Purpose:  Get path for Printer managment scripts
'***********************************************
Private Function GetPrintVBSPath

    Dim oWMI, oItem, colItems
    Dim sComputer, VerOS, VerBig, Ver9x, Version9x, OS

    ' Here is where we interrogate the Operating System
    ' On Error Resume Next

    ' Get the computer name dot = this computer.
    sComputer = "."
    ' This is where WMI interrogates the operating system
    Set oWMI = GetObject("winmgmts:\\" & sComputer & "\root\cimv2")

    Set colItems = oWMI.ExecQuery("Select * from Win32_OperatingSystem",,48)

    ' Here we filter Version from the dozens of properties
    For Each oItem in colItems
        VerBig = Left(oItem.Version,3)
    Next

    ' Spot VerBig variable in previous section
    ' Note the output variable is called OSystem

    Select Case VerBig
        Case "6.1" GetPrintVBSPath = oEnv("SYSTEMROOT") & "\System32\Printing_Admin_Scripts\en-US"
        Case "6.0" GetPrintVBSPath = oEnv("SYSTEMROOT") & "\System32\Printing_Admin_Scripts\en-US"
        Case "5.2" GetPrintVBSPath = oEnv("SYSTEMROOT") & "\System32" 
        Case "5.1" GetPrintVBSPath = oEnv("SYSTEMROOT") & "\System32" 
        Case "5.0" GetPrintVBSPath = oEnv("SYSTEMROOT") & "\System32" 
        Case Else GetPrintVBSPath = oEnv("SYSTEMROOT") & "\System32\Printing_Admin_Scripts\en-US"
    End Select
   
End Function